/*
  Name: DL programowanie zadanie 15 z rozdziau 16 ksiki Thinking in C++
  Author: Piotr Leo
  Date: 27-06-06 19:28
  Description: Zmodyfikuj programy C15:OStack.h oraz C15:OStackTest.cpp,
przeksztacajc klas Stack w szablon, dziki czemu bdzie on automatycznie
wielokrotnie dziedziczy zarwno po zawartej w nim klasie, jak i po klasie
Object. Skonkretyzowana klasa Stack powinna pobiera i zwraca wycznie
wskaniki zawartego w niej typu.
*/
//: C15:OStack.h
// From Thinking in C++, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 2000
// Copyright notice in Copyright.txt
// Using a singly-rooted hierarchy
#ifndef OSTACK_H
#define OSTACK_H
#include <iostream>

using namespace std;

class Object {
public:
  virtual ~Object() = 0;
};

// Required definition:
inline Object::~Object() {cout<<"Wywolanie destruktora klasy Object!"<<endl;}

template<class T>
class Stack {
  struct Link {
    T* data;
    Link* next;
    Link(T* dat, Link* nxt) : 
      data(dat), next(nxt) {}
  }* head;
public:
  Stack() : head(0) {}
  ~Stack(){ 
    while(head)
      delete pop();
  }
  void push(T* dat) {
    head = new Link(dat, head);
  }
  T* peek() const { 
    return head ? head->data : 0;
  }
  T* pop() {
    if(head == 0) return 0;
    T* result = head->data;
    Link* oldHead = head;
    head = head->next;
    delete oldHead;
    return result;
  }
};
#endif // OSTACK_H ///:~
