/*
  Name: DL programowanie zadanie 15 z rozdziau 16 ksiki Thinking in C++
  Author: Piotr Leo
  Date: 27-06-06 19:28
  Description: Zmodyfikuj programy C15:OStack.h oraz C15:OStackTest.cpp,
przeksztacajc klas Stack w szablon, dziki czemu bdzie on automatycznie
wielokrotnie dziedziczy zarwno po zawartej w nim klasie, jak i po klasie
Object. Skonkretyzowana klasa Stack powinna pobiera i zwraca wycznie
wskaniki zawartego w niej typu.
*/
//: C15:OStackTest.cpp
// From Thinking in C++, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 2000
// Copyright notice in Copyright.txt
//{T} OStackTest.cpp
#include "OStack.h"
#include "require.h"
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

// Use multiple inheritance. We want 
// both a string and an Object:
class MyString: public string, public Object {
public:
  ~MyString() {
    cout << "deleting string: " << *this << endl;
  }
  MyString(string s) : string(s) {}
};

int main(int argc, char* argv[]) {
  requireArgs(argc, 1); // File name is argument
  ifstream in(argv[1]);
  assure(in, argv[1]);
  Stack<Object> textlines;      
  string line;
  // Read file and store lines in the stack:
  while(getline(in, line))
    textlines.push(new MyString(line));
  // Pop some lines from the stack:
  MyString* s;
  for(int i = 0; i < 10; i++) {
    if((s=(MyString*)textlines.pop())==0) break;
    cout << *s << endl;
    delete s; 
  }
  cout << "Letting the destructor do the rest:"
    << endl;
    system("pause");
} ///:~
